
#ifndef ORB2ORB_CONNECTION_H
#define ORB2ORB_CONNECTION_H

enum O2oConnectionDirection { r, w };

class O2oConnection 
{
	public:
						O2oConnection( std::string connectionName, 
						       	       std::string direction, 
						               std::string orbtag, 
						               std::string orbname, 
						               std::string queue );
						~O2oConnection( void );
	
		void				run( void );

		void				set( std::string key, std::string val );
		void				set( std::string key, int val );
		void				set( std::string key, double val );
		void				set( std::string key, bool val );
		int				getInt( std::string key );
		bool				getBool( std::string key );
		double				getDouble( std::string key );
		std::string			getString( std::string key );

		std::string			connectionName( void );

		void				verboseDescribe( void );

	private:

		std::string			m_connectionName;
		std::string			m_orbtag;
		std::string			m_orbname;
		std::string			m_queue;
		std::string			m_connectionStatus;
		std::string			m_match;
		std::string			m_reject;
		int				m_maxqueue;
		int				m_queueCount;
		double				m_starttime;
		double				m_endtime;
		double				m_tooOld;
		double				m_tooNew;
		double				m_lastPacketTime;
		bool				m_checkUnstuff;
		bool				m_suppressUnstuffErrors;
		O2oConnectionDirection		m_direction;
		std::shared_ptr<O2oQueue>	m_oq;
		std::shared_ptr<OrbTag>		m_ot;
};

#endif
