
#ifndef ORB2ORB_EXCEPTION_H
#define ORB2ORB_EXCEPTION_H

#include <stdexcept>

class O2oException : public std::runtime_error
{
	public:
			O2oException( std::string what ) : std::runtime_error( what ) {};
			~O2oException( void ) {};
};

class O2oEOFException : public O2oException
{
	public:
			O2oEOFException( std::string what ) : O2oException( what ) {};
			~O2oEOFException( void ) {};
};

class O2oTimeoutException : public O2oException
{
	public:
			O2oTimeoutException( std::string what ) : O2oException( what ) {};
			~O2oTimeoutException( void ) {};
};

class O2oNodataException : public O2oException
{
	public:
			O2oNodataException( std::string what ) : O2oException( what ) {};
			~O2oNodataException( void ) {};
};

class O2oDNEException : public O2oException
{
	public:
			O2oDNEException( std::string what ) : O2oException( what ) {};
			~O2oDNEException( void ) {};
};

class O2oOrbClosedException : public O2oException
{
	public:
			O2oOrbClosedException( std::string what ) : O2oException( what ) {};
			~O2oOrbClosedException( void ) {};
};

class O2oOrbOpenException : public O2oException
{
	public:
			O2oOrbOpenException( std::string what ) : O2oException( what ) {};
			~O2oOrbOpenException( void ) {};
};

class O2oOrbPositioningException : public O2oException
{
	public:
			O2oOrbPositioningException( std::string what ) : O2oException( what ) {};
			~O2oOrbPositioningException( void ) {};
};

class O2oUnstuffException : public O2oException
{
	public:
			O2oUnstuffException( std::string what ) : O2oException( what ) {};
			~O2oUnstuffException( void ) {};
};

#endif
