
#ifndef ORB2ORB_QUEUE_H
#define ORB2ORB_QUEUE_H

#include "brttutil.h"

class OrbPacket;

class O2oQueue 
{
	public:
								O2oQueue( std::string queueName );
								~O2oQueue( void );
	
		void						setProducer( std::string producerName );
		void						setConsumer( std::string consumerName, int maxqueue );

		void						push( std::shared_ptr<OrbPacket>& op );
		void						push_eof( std::string producerName );
		std::shared_ptr<OrbPacket>			pop( std::string consumerName );
		std::string					getString( std::string key );
		int						getQueueCount( std::string consumerName );

	private:

		std::string					m_queueName;

		Pmtmanagedfifo*					m_fifo;
		std::unordered_map<std::string,Pmtfifo*>	m_consumers;
};

#endif
