
#ifndef ORBPACKET_H
#define ORBPACKET_H

enum OrbPacketUnstuffs { unknown, no, yes };

class OrbPacket 
{
	public:
							OrbPacket( std::shared_ptr<OrbTag> ot_source, int pktid, char* srcname, double pkttime, char* pkt, int nbytes );
							OrbPacket( std::string msg );
							OrbPacket( Pf* pf );
							~OrbPacket( void );

		void					put( std::shared_ptr<OrbTag> ot );

		int					getInt( std::string key );
		std::string				getString( std::string key );
		bool					getBool( std::string key );
		double					getDouble( std::string key );

		std::string				describe( void );

		static std::shared_ptr<OrbPacket>	reap( std::shared_ptr<OrbTag> ot );
		static std::shared_ptr<OrbPacket>	reap_timeout( std::shared_ptr<OrbTag> ot, double maxseconds );
	
	private:

		bool					checkUnstuffs( void );
		void					unstuff( void );

		int					m_pktid;
		int					m_nbytes;
		int					m_bufsize;
		int					m_content;
		bool					m_isInternalLog;
		bool					m_containsStuffed;
		bool					m_containsUnstuffed;
		OrbPacketUnstuffs			m_unstuffs;
		double					m_pkttime;
		char					m_srcname[ORBSRCNAME_SIZE];
		char*					m_pktbuf;
		Packet*					m_pkt;
		std::string				m_packetSource;
};

typedef struct OrbPacketHookData_ {

	std::shared_ptr<OrbPacket> op;

} OrbPacketHookData;

void spOrbPacket_hookfree( void* p );
Hook* spOrbPacket_hookcopy( Hook* h );

#endif
