
#ifndef ORBTAG_H
#define ORBTAG_H

class OrbHandle;
class O2oConnection;

class OrbTag
{
	public:
										OrbTag( std::string orbtag, std::string orbname );
										OrbTag( std::string orbname );
										~OrbTag( void );

		void								open( std::string direction );
		int								select( std::string match );
		int								reject( std::string reject );
		int								after( double atime );
		void								smartReposition( double starttime );
		int								put( char* srcname, 
										     double pkttime, 
										     char* pktbuf, 
										     int nbytes ); 

		bool								isOpen( void );
		std::string							getJointName( void );
		std::string							getString( std::string key );
		int								getNewestPktid( void );
		int								getInt( std::string key );
		double								getDouble( std::string key );
		void								setInt( std::string key, int v );
		void								setDouble( std::string key, double v );
		void								setOrbPosition( int pktid, double pkttime );

		static std::shared_ptr<OrbTag>					getOrbTag( std::string orbtag, 
											   std::string orbname = "", 
											   bool create = false );
		static std::shared_ptr<OrbTag>					createOrbTagFromOrbName( std::string orbname );

	private:

		std::shared_ptr<OrbHandle>					m_orbHandle;
		std::mutex							m_orbtagMutex;
		std::string							m_orbtag;
		int								m_orbfd;
		std::string							m_match;
		std::string							m_reject;
		int								m_pktid;
		double								m_pkttime;
		std::vector<O2oConnection>					m_connections;	// WARNING raw object pointers 
												// not wrapped by std::shared_ptr

		static std::unordered_map<std::string,std::shared_ptr<OrbTag>>	s_orbTags;
		static int							s_autoOrbTagCount;
};

#endif
